<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" label-width="100px" v-loading="formLoading">
      <el-form-item :label="t('newHosts.hostsId')" prop="hostsId">
        <el-input v-model="formData.hostsId" :placeholder="t('newHosts.placeHostsId')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.hostsLevel')" prop="hostsLevel">
        <el-input v-model="formData.hostsLevel" :placeholder="t('newHosts.placeHostsLevel')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.hostsCoins')" prop="hostsCoins">
        <el-input v-model="formData.hostsCoins" :placeholder="t('newHosts.placeHostsCoins')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.invitationType')" prop="invitationType">
        <el-select v-model="formData.invitationType" :placeholder="t('newHosts.placeInvitationType')">
          <el-option v-for="dict in getIntDictOptions(DICT_TYPE.HOSTS_INVITATION_TYPE)" :key="dict.value"
            :label="$t(dict.label)" :value="dict.value" />
        </el-select>

      </el-form-item>
      <el-form-item :label="t('newHosts.onlineFans')" prop="onlineFans">
        <el-input v-model="formData.onlineFans" :placeholder="t('newHosts.placeOnlineFans')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.fans')" prop="fans">
        <el-input v-model="formData.fans" :placeholder="t('newHosts.placeFans')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.fllowernum')" prop="fllowernum">
        <el-input v-model="formData.fllowernum" :placeholder="t('newHosts.placeFllowernum')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.yesterdayCoins')" prop="yesterdayCoins">
        <el-input v-model="formData.yesterdayCoins" :placeholder="t('newHosts.placeYesterdayCoins')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.hostsCountryinfo')" prop="country">
        <el-input v-model="formData.country" :placeholder="t('newHosts.placeCountry')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.hostsKind')" prop="hostsKind">
        <el-input v-model="formData.hostsKind" :placeholder="t('newHosts.placeHostsKind')" />
      </el-form-item>
      <el-form-item :label="t('newHosts.isAssigned')" prop="isAssigned">
        <el-select v-model="formData.isAssigned" :placeholder="t('newHosts.placeIsAssigned')">
          <el-option v-for="dict in getIntDictOptions(DICT_TYPE.INT_TRUE_FLASE)" :key="dict.value" :label="dict.label"
            :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('newHosts.userId')" prop="userId">
        <el-input v-model="formData.userId" :placeholder="t('newHosts.placeUserId')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { NewHostsApi, NewHostsVO } from '@/api/server/newhosts'

/** 主播数据管理 表单 */
defineOptions({ name: 'NewHostsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  hostsId: undefined,
  hostsLevel: undefined,
  hostsCoins: undefined,
  invitationType: undefined,
  onlineFans: undefined,
  fans: undefined,
  fllowernum: undefined,
  yesterdayCoins: undefined,
  country: undefined,
  hostsKind: undefined,
  isAssigned: undefined,
  userId: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await NewHostsApi.getNewHosts(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as NewHostsVO
    if (formType.value === 'create') {
      await NewHostsApi.createNewHosts(data)
      message.success(t('common.createSuccess'))
    } else {
      await NewHostsApi.updateNewHosts(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    hostsId: undefined,
    hostsLevel: undefined,
    hostsCoins: undefined,
    invitationType: undefined,
    onlineFans: undefined,
    fans: undefined,
    fllowernum: undefined,
    yesterdayCoins: undefined,
    country: undefined,
    hostsKind: undefined,
    isAssigned: undefined,
    userId: undefined
  }
  formRef.value?.resetFields()
}
</script>